/*  
 * hood.js
 * 
 * Copyright ( c ) 2016 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 *
 * Created on : Thu Dec 08 15:35:26 KST 2016
 * Owner      : SRI
 * Author     : namit.bansal@samsung.com
 */

var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'ui.router']);

app.config(['$stateProvider', function ($stateProvider) {
        var MainLoadingPage = {
            name: 'MainLoadingPage',
            url: '/',
            templateUrl: 'common/views/splash.html'
        },
        BurnerHomePage = {
            name: 'BurnerHomePage',
            url: '/',
            templateUrl: 'COOKTOP/views/BurnerHomeScreen.html'
        },
        HoodTimerPage = {
            name: 'HoodTimerPage',
            url: '/',
            templateUrl: 'HoodTimerScreen.html'
        },
        SettingPage = {
            name: 'SettingPage',
            url: '/',
            templateUrl: 'COOKTOP/views/SettingScreen.html'
        },
        AboutPage = {
            name: 'AboutPage',
            url: '/',
            templateUrl: 'COOKTOP/views/AboutScreen.html'
        },
        SmartCarePage = {
            name: 'SmartCarePage',
            url: '/',
            templateUrl: 'COOKTOP/views/SmartCareScreen.html'
        },
        SmartCareNoErrorPage = {
            name: 'SmartCareNoErrorPage',
            url: '/',
            templateUrl: 'COOKTOP/views/SmartCareNoErrorScreen.html'
        },
        ErrorPage = {
                name: 'ErrorPage',
                url: '/',
                templateUrl: 'COOKTOP/views/ErrorScreen.html'
            };

        $stateProvider.state(MainLoadingPage);
        $stateProvider.state(BurnerHomePage);
        $stateProvider.state(HoodTimerPage);
        $stateProvider.state(SettingPage);
        $stateProvider.state(AboutPage);
        $stateProvider.state(SmartCarePage);
        $stateProvider.state(SmartCareNoErrorPage);
        $stateProvider.state(ErrorPage);

    }]);

app.run(['$state', function ($state) {
        $state.transitionTo('MainLoadingPage');
    }]);

app.controller("hoodAppController", ['$scope', '$state', 'SHPService', 'toaster', '$timeout', '$interval', hoodAppController]);

function hoodAppController($scope, $state, SHPService, toaster, $timeout, $interval) {
    var langArr = Object.keys(LANGUAGE_FILE.language), Debug_tag = 'HD : ', justFirstTime = true, configTimer = null, Sec20Call = 20000, promiseAbout,
            errorRemoved = true, changeSmartCarePage = false, doNotChangeScreen = false, parseNotificationFlag = false, promiseFanImage = null,
            hoodTimerDrag = $("#hoodTimerDrag"), roundShape, scroll_middle_area = document.getElementById("scrollable_area_others");

    var HOOD_SCREENS = {
        HOOD_MAIN_LOADING_PAGE: 1,
        HOOD_BURNER_HOME_PAGE: 2,
        HOOD_HOOD_TIMER_PAGE: 4,
        HOOD_SETTING_PAGE: 5,
        HOOD_ABOUT_PAGE: 6,
        HOOD_ERROR_PAGE: 7,
        HOOD_SMART_CARE_PAGE: 8,
        HOOD_SMART_CARE_NO_ERROR_PAGE: 9
    },
        HOOD_COMMANDS = {
            "hoodTimer": "hoodTimer",
            "hoodPower": "hoodPower",
            "hoodLight": "hoodLight",
            "hoodFan": "hoodFan",
            "getDevices": "getDevices",
            "runOnNative": "runOnNative",
            "kitchenTimer": "kitchenTimer",
            "showModuleVersion": "showModuleVersion",
            "smartCareDiagnosis": "smartCareDiagnosis"
        },
        HOOD_ALERT_STATE = {
            ALERT_NONE: 0,
            ALERT_START_COOKING: 1,
            ALERT_CANCEL_COOKING: 2,
            ALERT_CONNECTION_ERROR: 3,
            ALERT_DEVELOPER_INFO: 4,
            ALERT_TIMER_FINISH: 5,
            ALERT_CHILD_LOCK: 6,
            ALERT_HOOD_TIMER_FINISH: 7,
            ALERT_SERVICE_CALL: 8,
        };

    if (langArr.indexOf(LANG.toUpperCase()) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    $scope.isKoreanLanguage = LANG.toUpperCase().substring(0, 2) === "KO";
    $scope.isSpanishLanguage = LANG.toUpperCase().substring(0, 2) === "ES";
    $scope.isFrenchLanguage = LANG.toUpperCase().substring(0, 2) === "FR";
    $scope.switchON = 'I';
    $scope.switchOff = 'O';
    if (LANG.toUpperCase().indexOf('EN') !== -1) {
        $scope.switchON = 'ON';
        $scope.switchOff = 'OFF';
    }

    loadVariables();

    function isTextInput(node) {
        return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
    }

    document.addEventListener('touchend', function (e) {
        if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
            document.activeElement.blur();
        }
    }, false);

    function loadVariables() {
        $scope.isStatic = false;
        $scope.isAppV2 = false;
        $scope.hoodOff = false;
        $scope.showHood = false;
        $scope.hoodLight = false;
        $scope.loadingBar = false;
        $scope.showAutoSpeed = false;
        $scope.showSmartCare = false;
        $scope.isTempFocusOn = false;
        $scope.ch0FlexUpperOn = false;
        $scope.ch0FlexLowerOn = false;
        $scope.ch1FlexUpperOn = false;
        $scope.ch1FlexLowerOn = false;
        $scope.cTopTabSelected = false;
        $scope.appAtForeground = false;
        $scope.showKitchenTimer = false;
        $scope.headerBarVisible = false;
        $scope.TabsVisibleAtPage = false;
        $scope.mainLoadingScreen = false;
        $scope.moreOptionVisible = false;
        $scope.showFullScreenPopup = false;
        $scope.showMenuOptionPopup = false;
        $scope.remoteControlEnabled = false;

        $scope.checkResponse = [];
        $scope.runningBurner = [];

        $scope.hoodTimer = 0;
        $scope.selectedFanValue = 1;
        $scope.flexCoilSelectedValue = -1;

        $scope.hoodImage = '';
        $scope.fanStatus = 'low';
        $scope.HoodTimerState = 'Ready';
        $scope.selectedBurnerDetail = '';
        $scope.hoodLightPosition = 'off';
        $scope.fanText = "WEBMOB_device_hood_low";
        $scope.timerStopText = $scope.translation.WEBMOB_device_hood_set_time_guide4;
        $scope.timerText = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_step1;
        $scope.startStopState = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start;
        $scope.currentScreen = HOOD_SCREENS.HOOD_MAIN_LOADING_PAGE;

        $scope.init = init;
        $scope.closeApp = closeApp;
        $scope.onBackPressed = onBackPressed;
        $scope.callGetDevice = callGetDevice;
        $scope.parseStaticData = parseStaticData;
        $scope.parseDeviceData = parseDeviceData;
        $scope.handleStatusCode = handleStatusCode;
        $scope.updateDeviceData = updateDeviceData;
        $scope.parseNotification = parseNotification;
        $scope.onBackPressedEvent = onBackPressedEvent;
        $scope.parseConfiguration = parseConfiguration;
        $scope.requestFailHandler = requestFailHandler;
        $scope.parseRequestAccepted = parseRequestAccepted;
        $scope.parseRequestResponse = parseRequestResponse;
        $scope.parseModuleInformation = parseModuleInformation;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;

        $scope.noScroll = noScroll;
        $scope.goToAbout = goToAbout;
        $scope.goToSettings = goToSettings;
        $scope.inputKeyDown = inputKeyDown;
        $scope.addHoodTimer = addHoodTimer;
        $scope.onAboutAction = onAboutAction;
        $scope.hoodFanButton = hoodFanButton;
        $scope.gotoHoodTimer = gotoHoodTimer;
        $scope.showFanOption = showFanOption;
        $scope.hideFanOption = hideFanOption;
        $scope.hideDummyInbox = hideDummyInbox;
        $scope.showDummyInbox = showDummyInbox;
        $scope.hideMenuOption = hideMenuOption;
        $scope.showMenuOption = showMenuOption;
        $scope.resetHoodTimer = resetHoodTimer;
        $scope.startHoodTimer = startHoodTimer;
        $scope.hoodLightButton = hoodLightButton;
        $scope.versionTouchEnd = versionTouchEnd;
        $scope.hoodPowerButton = hoodPowerButton;
        $scope.showUsageHelpPage = showUsageHelpPage;
        $scope.versionTouchStart = versionTouchStart;
        $scope.closeUsageHelpPage = closeUsageHelpPage;
        $scope.onAlertButton1Click = onAlertButton1Click;
        $scope.onAlertButton2Click = onAlertButton2Click;
        $scope.smartcareerrorcheck = smartcareerrorcheck;
        $scope.doOnServiceCallPopup = doOnServiceCallPopup;
        $scope.updateHoodTimerValue = updateHoodTimerValue;
        $scope.doValidationForHoodTimer = doValidationForHoodTimer;

        $scope.fanMenuList = [{
                id: 1,
                title: 'WEBMOB_device_hood_low'
            }, {
                id: 2,
                title: 'WEBMOB_device_hood_medium'
            }, {
                id: 3,
                title: 'WEBMOB_device_hood_high'
            }, {
                id: 4,
                title: 'WEBMOB_device_hood_boost'
            }, {
                id: 5,
                title: 'WEBMOB_device_us_hood_auto'
            }];
    }

    function debugMessage(msg) {
        if (false) {
            console.log(Debug_tag + ": " + msg + '  >> called from ' + arguments.callee.caller.name);
        }
    }

    function init() {
        debugMessage('init called ' + $scope.appAtForeground + justFirstTime);
        if (!$scope.appAtForeground && justFirstTime) {
            $scope.HoodInfo = {Alarms: [{
                        id: "0",
                        alarmType: "",
                        code: "",
                        triggeredTime: ""
                    }],
                ConfigurationLink: {
                    href: "/devices/1/configuration"
                },
                Diagnosis: {
                    diagnosisStart: "Ready"
                },
                InformationLink: {
                    href: "/devices/1/information"
                },
                Mode: {
                    options: [{
                            DeviceType: "",
                            FanSpeed: 0,
                            Bluetooth: 'On',
                            Hood: '',
                            Lamp: false,
                            BTState: 15,
                            AutoMode: 'On',
                            ShutOffTimerSet: 0,
                            ShutOffTimerCurrent: 0,
                            ShutOffTimerState: 'Ready'}]
                },
                Operation: {
                    power: "Off"
                },
                connected: false,
                description: "TP6X_CT_16K_HOOD",
                id: "1",
                name: "Hood",
                resources: ["Alarms",
                    "Configuration",
                    "Diagnosis",
                    "Doors",
                    "Information",
                    "Mode",
                    "Operation"],
                type: "CookTop",
                uuid: "F8042EEB-AD39-0000-0000-000000000001"
            };
        }
    }

    function updateDeviceData(data) {
        //debugMessage("updateDeviceData " + data);
        SHPService.updateDeviceData($scope, data);
    }

    function callGetDevice() {
        debugMessage("callGetDevice ");
        SHPService.getDevices($scope);
    }

    function configurationCall() {
        if (!$scope.isStatic) {
            debugMessage("configurationCall");
            if (!!!configTimer) {
                configTimer = $interval(function () {
                    debugMessage("configurationCall Interval call");
                    //nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
                    $scope.appAtForeground = true;
                    SHPService.sendSHPCommand("GET", "/" + $scope.peerId + "/devices", "", false);
                }, Sec20Call);
            }
        }
    }

    function parseStaticData() {
        debugMessage("parseStaticData");
        init();
        initializeScreen();
        $scope.hoodTimer = 10;
        $scope.HoodInfo.Mode.options[0].Hood = 'connected';
        $scope.HoodInfo.Mode.options[0].Bluetooth = 'On';
        $scope.HoodInfo.Operation.power = 'On';
        showCurrentScreen();
    }

    function parseRequestAccepted(response) {
        debugMessage("parseRequestAccepted configInfo : " + JSON.stringify(response));
    }

    function parseRequestResponse(response) {
        debugMessage("parseRequestResponse");
        if (angular.isDefined(response["status"]) && response["status"] === 99000) {
            showConnectionFailurePopup();
        }
        if (angular.isDefined(response["status"]) && (response["status"] >= 200 || response.status < 300)) {
            $scope.handleStatusCode(response.status, response);
        }
        if (angular.isDefined(response["data"]["Configuration"])) {
            parseConfiguration(response["data"]["Configuration"], response.resourceURL);
        }
        if (angular.isDefined(response["data"]["Information"])) {
            parseModuleInformation(response["data"]["Information"]);
        }
        if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
            if (!response["data"][0]["Device"]["scsConnectionState"]) {
                showConnectionFailurePopup();
            } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                $scope.closeConnectionFailurePopup();
                $scope.autoCall = true;
                $scope.appAtForeground = true;
                callGetDevice();
            }
            return;
        }

        if (angular.isDefined(response["data"]["Devices"])) {
            init();
            parseDeviceData(response.data.Devices);
            if (!!!$scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
                SHPService.clearStopVarArray();
            }
        }
    }

    function parseDeviceData(devices) {
        debugMessage("deviceUuid from app.js is :" + $scope.deviceUuid);
        if (angular.isDefined(devices) && angular.isDefined(devices[0]) && angular.isDefined(devices[0]["uuid"])) {
            if ($scope.deviceUuid !== devices[0]["uuid"] && $scope.deviceUuid !== devices[1]["uuid"]) {
                debugMessage("return due to missMatch UUID");
                return;
            }
        }

        debugMessage(JSON.stringify(devices));

        if (devices instanceof Array) { //Added a check to avoid error in case "devices" is not array 
            devices.forEach(function (value) {
                if (value["id"] === '1' || value["id"] === '16') {
                    parseHoodNotification(value);
                }
            });
        } else if (angular.isDefined(devices['Operation']) && devices['Operation'] === '') {
            // sometimes set is sending  devices as {"Operation":""}, added the condition just to avoid any issue that it can cause
            return;
        } else {
            //do nothing
        }
        $scope.appAtForeground = false;
        if (justFirstTime) {
            if (!$scope.isStatic) {
                nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
            }
            configurationCall();
            return;
        }
        if (!justFirstTime) {
            dismissLoadingBar(HOOD_COMMANDS.getDevices);
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseConfiguration(configInfo) {
        debugMessage("parseConfiguration configInfo : " + JSON.stringify(configInfo));
        $scope.parseConfig = true;
        parseNotificationFlag = true;
        if (angular.isDefined(configInfo["remoteControlEnabled"])) {
            $scope.remoteControlEnabled = configInfo["remoteControlEnabled"];
        }
        if (angular.isDefined(configInfo["region"])) {
            $scope.region = configInfo["region"];
        }
        if (justFirstTime) {
            dismissLoadingBar(HOOD_COMMANDS.getDevices);
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseNotification(response) {
        debugMessage("parseNotification ");
        if (angular.isDefined(response["softKeypadVisibility"])) {
            hideInputBoxFocus();
        }
        if (!angular.isDefined(response["data"])) {
            return;
        }
        if (response["data"] === "backPressed") {
            //if loding bar visible, don't handle back key
            if (!!!$scope.loadingBar) {
                onBackPressed();
            }
            return;
        }
        if (angular.isDefined(response["data"]["mobileTimeChanged"])) {
            return;
        }
        if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
            if (!response["data"][0]["Device"]["scsConnectionState"]) {
                showConnectionFailurePopup();
            } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                $scope.closeConnectionFailurePopup();
                $scope.autoCall = true;
                $scope.appAtForeground = true;
                callGetDevice();
            }
            return;
        }
        if (angular.isDefined(response["data"]["isApplicationActive"]) && !$scope.isStatic) {
            $scope.autoCall = true;
            $scope.appAtForeground = true;
            callGetDevice();
            return;
        } else {
            $scope.parseNotiLength = response["data"].length;
            response["data"].forEach(function (value) {
                $scope.parseNotiLength--;
                parseNotificationData(value);
            });
        }
    }


    function parseNotificationData(notification) {
        debugMessage("parseNotificationData : " + JSON.stringify(notification));
        if ($scope.checkResponse.indexOf(HOOD_COMMANDS.getDevices) !== -1) {
            debugMessage("ignore notification if getDevice requested ");
            return;
        }
        if (angular.isDefined(notification["uuid"])) {
            if ($scope.HoodInfo !== undefined && notification["uuid"] === $scope.HoodInfo.uuid) {
                parseHoodNotification(notification);
                if ($scope.parseNotiLength === 0) {
                    $scope.appAtForeground = false;
                    showCurrentScreen();
                }
            } else {
                debugMessage("parseNotificationData uuid not matched notification uuid " + notification["uuid"]);
                $scope.appAtForeground = true;
                SHPService.sendSHPCommand("GET", "/" + $scope.peerId + "/devices", "", false);
            }
        }
    }

    function parseModuleInformation(moduleInfo) {
        debugMessage("parseModuleInformation " + JSON.stringify(moduleInfo));
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(HOOD_COMMANDS.showModuleVersion);
            debugMessage("Infotext : " + $scope.moduleInfoText);
            showcustDialog(HOOD_ALERT_STATE.ALERT_DEVELOPER_INFO, $scope.translation.WEBMOB_common_version_info, $scope.moduleInfoText, $scope.translation.WEBMOB_common_ok, '');
        }
    }

    function parseHoodNotification(deviceData) {
        debugMessage("parseHoodNotification");
        if (angular.isDefined(deviceData["Configuration"])) {
            parseConfiguration(deviceData["Configuration"]);
        }
        if (!angular.isDefined($scope.HoodInfo) && !justFirstTime) {
            justFirstTime = true;
            init();
            justFirstTime = false;
        }
        if (angular.isDefined(deviceData["description"])) {
            $scope.HoodInfo.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.HoodInfo.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.HoodInfo.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.HoodInfo.Alarms[0].code = deviceData["Alarms"][0]["code"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.HoodInfo.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.HoodInfo.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.HoodInfo.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["Diagnosis"])) {
            if (angular.isDefined(deviceData["Diagnosis"]["diagnosisStart"])) {
                $scope.HoodInfo.Diagnosis.diagnosisStart = deviceData["Diagnosis"]["diagnosisStart"];
            }
            if ($scope.HoodInfo.Diagnosis.diagnosisStart === "Ready") {
                if (!$scope.appAtForeground && ($scope.currentScreen === HOOD_SCREENS.HOOD_SMART_CARE_PAGE || $scope.currentScreen === HOOD_SCREENS.HOOD_SMART_CARE_NO_ERROR_PAGE)) {
                    dismissLoadingBar(HOOD_COMMANDS.smartCareDiagnosis);
                    $scope.currentScreen = HOOD_SCREENS.HOOD_SMART_CARE_NO_ERROR_PAGE;
                    validateCurrentScreen('SmartCareNoErrorPage');
                }
            } else if ($scope.HoodInfo.Diagnosis.diagnosisStart === "Run") {
                $scope.currentScreen = HOOD_SCREENS.HOOD_SMART_CARE_PAGE;
                validateCurrentScreen('SmartCarePage');
            }
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.HoodInfo.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.HoodInfo.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                deviceData["Mode"]["options"].forEach(function (value) {
                    parseHoodInfoModeOptions(value);
                });
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                dismissLoadingBar(HOOD_COMMANDS.hoodPower);
                if (($scope.HoodInfo.Operation.power !== deviceData["Operation"]["power"]) && deviceData["Operation"]["power"] === 'Off') {
                    showToast($scope.translation.WEBMOB_device_hood_off);
                }
                $scope.HoodInfo.Operation.power = deviceData["Operation"]["power"];
                $scope.hoodOff = $scope.HoodInfo.Operation.power === 'Off' ? true : false;
                $scope.selectedFanValue = ($scope.HoodInfo.Operation.power === 'on' && !$scope.appAtForeground) ? 1 : $scope.selectedFanValue;
                setLightStatus();
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.HoodInfo.connected = deviceData["connected"];
        }
        if (angular.isDefined(deviceData["Device"])) {
            if (angular.isDefined(deviceData["Device"]["connected"])) {
                $scope.HoodInfo.connected = deviceData["Device"]["connected"];
            }
        }
        if (angular.isDefined(deviceData["name"])) {
            $scope.HoodInfo.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.HoodInfo.resources = deviceData["resources"];
            deviceData["resources"].forEach(function (value) {
                if ($scope.HoodInfo.Mode.options[0].DeviceType === 'NV9300K-/AA1' || $scope.HoodInfo.Mode.options[0].DeviceType === 'NV9300K-/AA2'
                        || $scope.HoodInfo.Mode.options[0].DeviceType === 'NV9300K-/AA3' || $scope.HoodInfo.Mode.options[0].DeviceType === 'NV9300K-/AA4') {
                    if (value.indexOf("Diagnosis") !== -1) {
                        $scope.showSmartCare = true;
                    }
                }
            });
        }
//        if (angular.isDefined(deviceData["resources"])) {
//            $scope.HoodInfo.resources = deviceData["resources"];
//        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.HoodInfo.type = deviceData["type"];
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.HoodInfo.uuid = deviceData["uuid"];
        }

    }

    function parseHoodInfoModeOptions(modeOptionData) {
        if (modeOptionData.indexOf("DeviceType") !== -1) {
            $scope.HoodInfo.Mode.options[0].DeviceType = modeOptionData.split("_")[1];
        }
        if (modeOptionData.indexOf("Bluetooth") !== -1) {
            $scope.HoodInfo.Mode.options[0].Bluetooth = modeOptionData.split("_")[1];
        }
        if (modeOptionData.indexOf("hood") !== -1) {
            $scope.HoodInfo.Mode.options[0].Hood = (modeOptionData.split("_")[1]).toLowerCase();
        }
        if (modeOptionData.indexOf("BTState") !== -1) {
            $scope.HoodInfo.Mode.options[0].BTState = Number(modeOptionData.split("_")[1]);
        }
        if (modeOptionData.indexOf("AutoMode") !== -1) {
            $scope.HoodInfo.Mode.options[0].AutoMode = modeOptionData.split("_")[1];
        }
        if (modeOptionData.indexOf("FanSpeed") !== -1) {
            var speed = modeOptionData.split("_")[1];
            $scope.HoodInfo.Mode.options[0].FanSpeed = Number(speed);
            $scope.selectedFanValue = $scope.HoodInfo.Mode.options[0].FanSpeed;
            setFanStatus($scope.selectedFanValue);
            dismissLoadingBar(HOOD_COMMANDS.hoodFan);
        }
        if (modeOptionData.indexOf("Lamp") !== -1) {
            $scope.HoodInfo.Mode.options[0].Lamp = modeOptionData.split("_")[1];
            $scope.hoodLight = $scope.HoodInfo.Mode.options[0].Lamp === 'On' ? true : false;
            setLightStatus();
            dismissLoadingBar(HOOD_COMMANDS.hoodLight);
        }
        if (modeOptionData.indexOf("ShutOffTimerState") !== -1) {
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState !== modeOptionData.split("_")[1]) {
                blurInputBox('hoodTimer');
            }
            $scope.HoodInfo.Mode.options[0].ShutOffTimerState = modeOptionData.split("_")[1];
            dismissLoadingBar(HOOD_COMMANDS.hoodTimer);
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Run' && $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent === 0) {
                $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent = 1;
            }
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Finish' && !justFirstTime && !$scope.appAtForeground) {
                showcustDialog(HOOD_ALERT_STATE.ALERT_HOOD_TIMER_FINISH, '', $scope.translation.WEBMOB_device_hood_time_left_guide, $scope.translation.WEBMOB_common_ok, '');
            }
            if (!$scope.appAtForeground) {
                if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Run') {
                    $scope.HoodTimerState = 'Run';
                    $scope.startStopHoodState = $scope.translation.WEBMOB_common_cooktop_pause;
                } else if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Pause') {
                    $scope.HoodTimerState = 'Pause';
                    $scope.startStopHoodState = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start;//'PAUSE'
                } else {
                    $scope.HoodTimerState = 'Ready';
                    $scope.startStopHoodState = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start;
                }
            }
        }
        if (modeOptionData.indexOf("ShutOffTimerCurrent") !== -1) {
            var val = Number(modeOptionData.split("_")[1]);
            $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent = val;
            $scope.hoodTimer = $scope.appAtForeground ? $scope.hoodTimer : val;
            hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", tab: 2});
            updateHoodTimerValue($scope.hoodTimer);
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Run') {
                dismissLoadingBar(HOOD_COMMANDS.hoodTimer);
            }
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent === 0 && $scope.HoodInfo.Mode.options[0].ShutOffTimerState !== 'Ready') {
                $scope.focuseRemoved = true;
            }
        }
        if (modeOptionData.indexOf("ShutOffTimerSet") !== -1) {
            $scope.HoodInfo.Mode.options[0].ShutOffTimerSet = Number(modeOptionData.split("_")[1]);
            //$scope.hoodTimer = $scope.appAtForeground || $scope.HoodInfo.Mode.options[0].ShutOffTimerSet <= 0 ? $scope.hoodTimer : shutOffTimerVal;
            if ($scope.HoodInfo.Mode.options[0].ShutOffTimerState === 'Run') {
                dismissLoadingBar(HOOD_COMMANDS.hoodTimer);
            }
        }
    }

    function handleStatusCode(status) {
        if (status === 204) {
            //loadingValues();
        }
    }

    function requestFailHandler(response) {
        debugMessage(JSON.stringify(response));
        $scope.loadingBar = false;
        $scope.checkResponse = [];
    }

    function showConnectionFailurePopup() {
        if (isTextInput(document.activeElement)) {
            document.activeElement.blur();
        }
        showcustDialog(HOOD_ALERT_STATE.ALERT_CONNECTION_ERROR, $scope.translation.WEBMOB_device_range_alarm_connection_failure_title, $scope.translation.WEBMOB_common_check_power_and_network, '', $scope.translation.WEBMOB_common_ok);
    }

    function closeConnectionFailurePopup() {
        $scope.showFullScreenPopup = false;
    }

    function preConditionValidation() {
        $scope.mainLoadingScreen = true;
        $scope.moreOptionVisible = false;
        $scope.showHoodTimer = false;
        $scope.settingOption = false;
        $scope.aboutOption = true;
        $scope.showHelpOption = false;
        doNotChangeScreen = false;
    }

    function validateCurrentScreen(screen) {
        preConditionValidation();
        switch (screen) {
            case 'MainLoadingPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = HOOD_SCREENS.HOOD_MAIN_LOADING_PAGE;
                $scope.deviceName = "";
                $scope.headerBarVisible = false;
                $scope.TabsVisibleAtPage = false;
                $scope.mainLoadingScreen = false;
                $state.transitionTo('MainLoadingPage');
                break;
            case 'BurnerHomePage':
                debugMessage("validate screen : " + screen + " show tab : " + $scope.showHood);
                $scope.currentScreen = HOOD_SCREENS.HOOD_BURNER_HOME_PAGE;
                $scope.moreOptionVisible = true;
                $scope.deviceName = $scope.translation.WEBMOB_device_hood_title;
                $scope.showHelpOption = true;
                $scope.hoodTimer = $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent;
                $scope.hoodTimerLeftTime = Number($scope.hoodTimer) > 1 ? $scope.translation.WEBMOB_device_cooktop_timer_left2.replace(/#1#/, $scope.hoodTimer) : $scope.translation.WEBMOB_device_cooktop_timer_left.replace(/#1#/, $scope.hoodTimer);
                $scope.headerBarVisible = true;
                $scope.mainPageDetailFUG = getLocalStorageData("mainHoodPageFUG");
                if (!$scope.mainPageDetailFUG && !$scope.cTopTabSelected) {
                    $scope.hoodPageFUG = true;
                    setLocalStorageData("mainHoodPageFUG", true);
                }
                if (angular.isDefined($state.current) && angular.isDefined($state.current.name) && screen !== $state.current.name) {
                    getFanImage();
                }
                $state.transitionTo('BurnerHomePage');
                break;
            case 'HoodTimerPage':
                $scope.headerBarVisible = true;
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = HOOD_SCREENS.HOOD_HOOD_TIMER_PAGE;
                $scope.TabsVisibleAtPage = false;
                doNotChangeScreen = true;
                roundShape = hoodTimerDrag;
                $scope.deviceName = $scope.translation.WEBMOB_device_hood_set_timer;
                $state.transitionTo('HoodTimerPage');
                document.getElementById("hoodTimerId").style.zIndex = 1;
                $scope.showHoodTimer = true;
                break;
            case 'ErrorPage':
                debugMessage("validate screen : " + screen);
                $scope.headerBarVisible = true;
                $scope.currentScreen = HOOD_SCREENS.HOOD_ERROR_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_range_comm_error;
                $scope.TabsVisibleAtPage = false;
                $scope.showMenuOptionPopup = false;
                $scope.showFullScreenPopup = false;
                doNotChangeScreen = true;
                $state.transitionTo('ErrorPage');
                break;
            case 'SettingPage':
                debugMessage("validate screen : " + screen);
                $scope.headerBarVisible = true;
                $scope.currentScreen = HOOD_SCREENS.HOOD_SETTING_PAGE;
                $scope.TabsVisibleAtPage = false;
                $scope.deviceName = $scope.translation.WEBMOB_common_settings;
                //settingPageOptionsValidation();
                doNotChangeScreen = true;
                $state.transitionTo('SettingPage');
                break;
            case 'AboutPage':
                debugMessage("validate screen : " + screen);
                $scope.headerBarVisible = true;
                $scope.currentScreen = HOOD_SCREENS.HOOD_ABOUT_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_about_device;
                $scope.TabsVisibleAtPage = false;
                doNotChangeScreen = true;
                $state.transitionTo('AboutPage');
                break;
            case 'SmartCarePage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = HOOD_SCREENS.WALLOVEN_SMART_CARE_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                $state.transitionTo('SmartCarePage');
                break;
            case 'SmartCareNoErrorPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = HOOD_SCREENS.WALLOVEN_SMART_CARE_NO_ERROR_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                $state.transitionTo('SmartCareNoErrorPage');
                break;
            default :
                debugMessage("validate screen else part: " + screen);
                break;
        }
    }

    function noScroll() {
        return ($scope.showFullScreenPopup || $scope.showMenuOptionPopup || $scope.samrtControlPopup
                || $scope.hoodPageFUG || $scope.showFanOptionPopup
                || $scope.loadingBar || !$scope.mainLoadingScreen);
    }

    function onBackPressedEvent(e) {
        //e.stopPropagation();
        onBackPressed();
    }

    function refreshValue() {
        debugMessage('All value reset');
    }

    function onBackPressed() {
        debugMessage("Back key pressed from : " + $scope.currentScreen);
        if ($scope.showFullScreenPopup || $scope.showMenuOptionPopup) {//any popup is open then close and return
            $scope.showFullScreenPopup && onAlertButton1Click();
            $scope.showMenuOptionPopup && hideMenuOption();
            return;
        }
        if ($scope.hoodPageFUG) {
            closeUsageHelpPage();
            return;
        }

        refreshValue();
        switch ($scope.currentScreen) {
            case HOOD_SCREENS.HOOD_BURNER_HOME_PAGE:
            case HOOD_SCREENS.HOOD_ERROR_PAGE:
            case HOOD_SCREENS.HOOD_MAIN_LOADING_PAGE:
                closeApp();
                break;
            case HOOD_SCREENS.HOOD_HOOD_TIMER_PAGE:
                doNotChangeScreen = false;
                $scope.showHoodTimer = false;
                validateCurrentScreen('BurnerHomePage');
                break;
            case HOOD_SCREENS.HOOD_SETTING_PAGE:
            case HOOD_SCREENS.HOOD_ABOUT_PAGE:
                doNotChangeScreen = false;
                showCurrentScreen();
                validateCurrentScreen('BurnerHomePage');
                break;
            case HOOD_SCREENS.HOOD_SMART_CARE_PAGE://Fallthrough
            case HOOD_SCREENS.HOOD_SMART_CARE_NO_ERROR_PAGE:
                validateCurrentScreen('AboutPage');
                break;
            default :
                debugMessage("Back key pressed from else " + $scope.currentScreen);
                //closeApp();
                break;
        }
    }

    function onAboutAction(reqParam) {
        if (reqParam === "smartcare") {
            $scope.currentScreen = HOOD_SCREENS.HOOD_SMART_CARE_PAGE;
            validateCurrentScreen('SmartCarePage');
            return;
        }
        nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
    }

    function hideMenuOption() {
        debugMessage('hideMenuOption');
        $scope.showMenuOptionPopup = false;
    }

    function showMenuOption() {
        debugMessage('showMenuOption');
        $scope.showMenuOptionPopup = true;
        $timeout(function () {
            document.getElementById("showMenufullScreenPopupId").style.zIndex = 999;
            document.getElementById("showMenuPopupDivId").style.zIndex = 999;
        }, 0);
    }

    function hideFanOption() {
        debugMessage('hideMenuOption');
        $scope.showFanOptionPopup = false;
    }

    function showFanOption() {
        debugMessage('showMenuOption');
        $scope.showFanOptionPopup = true;
        $timeout(function () {
            document.getElementById("fanModePopupId").style.zIndex = 999;
            document.getElementById("fanModePopupDivId").style.zIndex = 999;
        }, 0);
    }

    function versionTouchStart() {
        debugMessage("ABOUT command versionTouchStart ");
        if (!!!promiseAbout) {
            promiseAbout = $timeout(function () {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(HOOD_COMMANDS.showModuleVersion);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                }
            }, 5000);
        }
    }

    function showUsageHelpPage() {
        document.getElementById("scrollable_area_others").scrollTop = 0;
        $scope.hoodPageFUG = true;
    }

    function closeUsageHelpPage() {
        $scope.hoodPageFUG = false;
    }

    function doValidationForHoodTimer() {
        showDummyInbox();
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            //return;
        }
        $scope.hoodTimer = Number(document.getElementById('hoodTimer').value);
        if ($scope.hoodTimer > 99) {
            $scope.hoodTimer = 99;
            var text = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
            text = text.replace(/#1#/, 99);
            showToast(text);
        }
        if ($scope.hoodTimer < 0) {
            $scope.hoodTimer = 1;
            var text = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
            text = text.replace(/#1#/, '01');
            showToast(text);
        }

        if (!($scope.hoodTimer)) {
            $scope.hoodTimer = 1;
            var text = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
            text = text.replace(/#1#/, '01');
            showToast(text);
        }

        if (($scope.hoodTimer) % 1 !== 0 && ($scope.hoodTimer >= 00) && ($scope.hoodTimer <= 99)) {
            $scope.hoodTimer = Math.ceil(Number($scope.hoodTimer) / 1) * 1;
        }
        hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", tab: 2});
        updateHoodTimerValue($scope.hoodTimer);
    }

    function versionTouchEnd() {
        debugMessage("ABOUT command versionTouchEnd ");
        if (!!promiseAbout) {
            $timeout.cancel(promiseAbout);
            promiseAbout = null;
        }
    }

    function goToSettings() {
        debugMessage('goToSettings');
        validateCurrentScreen('SettingPage');
    }

    function gotoHoodTimer() {
        debugMessage('gotoHoodTimer');
        if ($scope.hoodOff) {
            showToast($scope.translation.WEBMOB_device_hood_off);
            return;
        }
        //showDummyInbox(); // CQ MW0600025669 - In Kitchen timer screen, key pad closed after getdevice response and any notification. 
        //$scope.hoodTimer = $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent;
        hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", max: 99, step: 1, tab: 2});
        updateHoodTimerValue($scope.hoodTimer);
        validateCurrentScreen('HoodTimerPage');
    }

    function addHoodTimer(time) {
        if ($scope.hoodOff) {
            showToast($scope.translation.WEBMOB_device_hood_off);
            return;
        }
        var value = 0;
        value = $scope.hoodTimer;
        value = value + Number(time);
        if (value > 99) {
            var text = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
            text = text.replace(/#1#/, 99);
            showToast(text);
            return;
        }
        $scope.hoodTimer = Number(value);
        $scope.updateHoodTimerValue($scope.hoodTimer);
        //sendHoodTimer(value);
        //if ($scope.HoodTimerState === 'Ready' || $scope.isStatic) {
        hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", tab: 2});
        //}
    }

    function startHoodTimer() {
        document.getElementById("hoodTimer").readOnly = true;
        if ($scope.hoodOff) {
            showToast($scope.translation.WEBMOB_device_hood_off);
            return;
        }
        var value = 0;
        value = $scope.hoodTimer;
        if (value > 99) {
            value = '99';
        } else if (value === 0) {
            value = '00';
        } else if (value > 0 && value < 10) {
            value = '0' + value;
        } else {
            value = '' + value;
        }
        if ($scope.startStopHoodState === $scope.translation.WEBMOB_device_hood_stop_button) {
            value = '00';
        }
        if ($scope.HoodTimerState === 'Ready' && value === '00') {
            showToast('Please set some Timer for cooking');//TODO STRING
        } else {
            sendHoodTimer(value);
        }
    }

    function resetHoodTimer() {
        debugMessage('resetHoodTimer');
        showDummyInbox();
        if ($scope.HoodTimerState === 'Run' || $scope.HoodTimerState === 'Pause') {
            sendHoodTimer(0);
        } else {
            $scope.hoodTimer = 0;
            hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", tab: 2});
        }
    }

    function sendHoodTimer(value) {
        var command;
        $scope.hoodTimer = Number(value);
        if (value === '00' || Number(value) < 1) {
            command = '{"Mode":{"options":["' + 'ShutOffTimerSet_' + value + '","ShutOffTimerState_Ready"]}}';
        } else if ($scope.startStopHoodState === $scope.translation.WEBMOB_common_cooktop_pause) {
            command = '{"Mode":{"options":["' + 'ShutOffTimerSet_' + value + '","ShutOffTimerState_Pause"]}}';
        } else {
            command = '{"Mode":{"options":["' + 'ShutOffTimerSet_' + value + '","ShutOffTimerState_Run"]}}';
        }
        debugMessage("Setting command " + command);
        if (!$scope.isStatic) {
            $scope.checkResponse.push(HOOD_COMMANDS.hoodTimer);
            SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/mode");
        }
    }

    function hoodPowerButton() {
        var command;
        if (!$scope.hoodOff) {
            command = '{"Operation": {"power": "Off"}}';
        } else {
            command = '{"Operation": {"power": "On"}}';
        }
        $scope.hoodOff = !$scope.hoodOff;
        debugMessage(command + "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/operation");
        if (!$scope.isStatic) {
            $scope.checkResponse.push(HOOD_COMMANDS.hoodPower);
            SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/operation");
        }
    }

    function setLightStatus() {
        if ($scope.hoodLight) {
            $scope.hoodLightPosition = $scope.hoodOff ? 'off_light_on' : 'on_light_on';
        } else {
            $scope.hoodLightPosition = 'off';
        }
    }

    function getFanImage() {
        var fanval = 0;
        $interval.cancel(promiseFanImage);
        fanval = 0;
        promiseFanImage = $interval(function () {
            fanval++;
            if (fanval < 10) {
                $scope.fanCurrentImage = '0' + fanval;
            } else if (fanval === 45) {
                fanval = 0;
                $scope.fanCurrentImage = '00';
            } else {
                $scope.fanCurrentImage = fanval;
            }
        }, 34);
    }

    function setFanStatus(value) {
        $timeout(function () {
            if (value === 1) {
                $scope.fanStatus = 'low';
                $scope.fanText = "WEBMOB_device_hood_low";
            } else if (value === 2) {
                $scope.fanStatus = 'med';
                $scope.fanText = "WEBMOB_device_hood_medium";
            } else if (value === 3) {
                $scope.fanStatus = 'high';
                $scope.fanText = "WEBMOB_device_hood_high";
            } else if (value === 4) {
                $scope.fanStatus = 'boost';
                $scope.fanText = "WEBMOB_device_hood_boost";
            } else if (value === 5) {
                $scope.fanStatus = 'auto';
                $scope.fanText = "WEBMOB_device_us_hood_auto";
            }
        }, 34);
    }

    function hoodFanButton(value) {
        if ($scope.selectedFanValue === value) {
            return;
        }
        var command;
        getFanImage();
        setFanStatus(value);
        $scope.selectedFanValue = value;
        command = '{"Mode":{"options":["FanSpeed_' + value + '"]}}';
        debugMessage(command + "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/mode");
        if (!$scope.isStatic) {
            $scope.checkResponse.push(HOOD_COMMANDS.hoodFan);
            SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/mode");
        }
        hideFanOption();
    }

    function hoodLightButton() {
        var command, value = 'Off';
        $scope.hoodLight = !$scope.hoodLight;
        setLightStatus();
        value = $scope.hoodLight ? 'On' : 'Off';
        command = '{"Mode":{"options":["Lamp_' + value + '"]}}';
        debugMessage(command + "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/mode");
        if (!$scope.isStatic) {
            $scope.checkResponse.push(HOOD_COMMANDS.hoodLight);
            SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/" + $scope.HoodInfo.id + "/mode");
        }

    }

    function goToAbout() {
        debugMessage('goToAbout');
        validateCurrentScreen('AboutPage');
    }

    function closeApp() {
        debugMessage('closeApp');
        nativeInterface.runOnNative("closeWebApp", "");
    }

    function dismissLoadingBar(value) {
        debugMessage("dismissLoadingBar " + $scope.checkResponse + " value " + value);
        if ($scope.appAtForeground) {
            return;
        }

        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            dismissLoadingBar(value);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }

    function initializeScreen() {
        debugMessage('initializeScreen  and all model check');
        if ($scope.HoodInfo === undefined) {
            return;
        }
        $scope.DeviceModelName = $scope.HoodInfo.Mode.options[0].DeviceType;
        debugMessage('DeviceModelName ' + $scope.DeviceModelName);
        $scope.showAutoSpeed = $scope.DeviceModelName === 'NK9900MM';
        $scope.hoodBoostB = $scope.DeviceModelName.indexOf("NK7000") > -1;
        $scope.hoodImage = $scope.hoodBoostB ? '7000p' : $scope.DeviceModelName === 'NK9000MM' ? '9000' : '';
        $scope.fanBtnTextL = $scope.hoodBoostB ? "WEBMOB_device_hood_low_dacor" : "WEBMOB_device_hood_low";
        $scope.fanBtnTextM = $scope.hoodBoostB ? "WEBMOB_device_hood_medium_dacor" : "WEBMOB_device_hood_medium";
        $scope.fanBtnTextH = $scope.hoodBoostB ? "WEBMOB_device_hood_high_dacor" : "WEBMOB_device_hood_high";
        $scope.fanBtnTextB = $scope.hoodBoostB ? "WEBMOB_device_hood_boost_dacor" : "WEBMOB_device_hood_boost";
        $scope.fanBtnTextA = $scope.hoodBoostB ? "WEBMOB_device_us_hood_auto" : "WEBMOB_device_us_hood_auto";
        $scope.mainLoadingScreen = true;
    }

    function showCurrentScreen() {
        debugMessage("showCurrentScreen called");
        if ($scope.HoodInfo === undefined) {
            debugMessage("HoodInfo is undefined");
            return;
        }

        if (!parseNotificationFlag && !$scope.isStatic) {
            debugMessage("waiting for getDevice response");
            return;
        }

        if (getAlarmStatusHood()) {
            return;
        }

        if (changeSmartCarePage && ($scope.currentScreen === HOOD_SCREENS.HOOD_SMART_CARE_NO_ERROR_PAGE || $scope.currentScreen === HOOD_SCREENS.HOOD_SMART_CARE_PAGE)) {
            debugMessage('return due to Smart Care');
            return;
        }
        //loadingValues();

        $scope.showHood = $scope.HoodInfo.Mode.options[0].Hood === 'connected' && $scope.HoodInfo.Mode.options[0].Bluetooth === 'On';

        if ($scope.hoodOff) {
            $scope.HoodTimerState = 'Ready';
            $scope.hoodTimer = 0;
            $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent = 0;
            hoodTimerDrag.roundSlider({value: $scope.hoodTimer, sliderType: "min-range", tab: 2});
        }
        if ($scope.currentScreen === HOOD_SCREENS.HOOD_HOOD_TIMER_PAGE) {
            debugMessage('return due to HOOD_HOOD_TIMER_PAGE screen');
            gotoHoodTimer();
            if ($scope.hoodOff && !$scope.showFullScreenPopup && $scope.alertState !== HOOD_ALERT_STATE.ALERT_HOOD_TIMER_FINISH) {
                validateCurrentScreen('BurnerHomePage');
            }
            return;
        }

        if (doNotChangeScreen) {
            debugMessage('return due to doNotChangeScreen');
            return;
        }

        justFirstTime = false;
        showScreen();
        debugMessage("Screen Loading finish and checkResponse values " + $scope.checkResponse);
    }

    function showScreen() {
        debugMessage("showScreen called");
        $timeout(function () {
            validateCurrentScreen('BurnerHomePage');
        }, 0);
    }

    function showHoodScreen() {
        debugMessage("showHoodScreen");
        $scope.hoodOff = $scope.HoodInfo.Operation.power === 'Off' ? true : false;
        $scope.hoodLight = $scope.HoodInfo.Mode.options[0].Lamp === 'On' ? true : false;
        $scope.selectedFanValue = $scope.HoodInfo.Operation.power === 'Off' ? 1 : $scope.selectedFanValue;
        $scope.hoodTimerLeftTime = Number($scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent) > 1 ? $scope.translation.WEBMOB_device_cooktop_timer_left2.replace(/#1#/, $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent) : $scope.translation.WEBMOB_device_cooktop_timer_left.replace(/#1#/, $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent);
        setLightStatus();
        setFanStatus($scope.selectedFanValue);
    }

    function updateHoodTimerValue(value) {
        debugMessage('updateHoodTimerValue according to ' + value);
        value = Number(value);
        document.getElementById('hoodTimer').value = value;
        if (value < 10) {
            document.getElementById('hoodTimer').value = '0' + value;
        }
        if (value >= 1) {
            $scope.timerTextHood = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_step2;
        } else {
            $scope.timerTextHood = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_step1;
        }
        if ($scope.HoodTimerState === 'Run' && (value === $scope.HoodInfo.Mode.options[0].ShutOffTimerCurrent || value < 1)) {
            $scope.startStopHoodState = $scope.translation.WEBMOB_common_cooktop_pause;
            $scope.timerStopTextHood = (value < 1) ? $scope.translation.WEBMOB_device_cooktop_kitchen_timer_step1 : $scope.translation.WEBMOB_device_hood_set_time_reset_for_stop;
        } else if ($scope.HoodTimerState === 'Pause') {
            $scope.startStopHoodState = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start;//'PAUSE'
            $scope.timerStopTextHood = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start_for_resume;
        } else {
            $scope.startStopHoodState = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_start;
            $scope.timerStopTextHood = $scope.translation.WEBMOB_device_cooktop_kitchen_timer_step2;
        }
    }

    function inputKeyDown(e) {
        if (e === undefined) {
            return;
        }
        var inputElement = document.activeElement;
        $timeout(function () {
            var sanitized = $(inputElement).val().replace(/[^0-9]/g, '');
            $(inputElement).val("");
            $(inputElement).val(sanitized);
        }, 0);
        var id = e.currentTarget.id;
        document.getElementById(id).onkeyup = function (e) {
            if (this.value === '' || !angular.isDefined(Number(this.value))) {
                e.preventDefault();
                roundShape.roundSlider({value: 0, sliderType: "min-range", tab: roundShape === hoodTimerDrag ? 2 : 1});
                document.getElementById(id).value = '';
                return;
            }
            checkForKey(e, this.value, id);
        };
    }

    function checkForKey(e, str, id) {
        var key = e.keyCode || e.which;
        if (key === 0 || key === 229) {
            key = str.charCodeAt(str.length - 1);
        }
        if ((key >= 96 && key <= 105 || key >= 48 && key <= 57) || key !== 8 || key !== 46) {
            var textValue = document.getElementById(id).value;
            roundShape.roundSlider({value: Number(textValue), sliderType: "min-range", tab: roundShape === hoodTimerDrag ? 2 : 1});
            document.getElementById(id).value = textValue;
        }

        if (key === 9 && (e.currentTarget.id === "kitchenTimer")) {
            showDummyInbox();
        }

        if (!(key >= 96 && key <= 105 || key >= 48 && key <= 57) && key !== 9 && key !== 8 && key !== 46) {
            e.preventDefault();
            return;
        }
    }

    function showDummyInbox() {
        debugMessage("showDummyInbox");
        debugMessage("BLUR CALLED>>>>>>>>>>>> showDummyInbox", arguments.callee.caller.name);
        if ((window.navigator.platform !== 'iPhone' || window.navigator.platform !== 'iPad')) {
            $scope.isTempFocusOn = true;
            document.activeElement.blur();
        }
    }

    function hideDummyInbox() {
        debugMessage("hideDummyInbox");
        $scope.isTempFocusOn = false;
    }

    function disableDummyInbox() {
        debugMessage("disableDummyInbox");
        if (document.getElementById("dummyInputBox") !== null) {
            document.getElementById("dummyInputBox").disabled = true;
        }
    }

    function showToast(txt) {
        debugMessage("showToast with txt " + txt);
        $timeout(function () {
            toaster.success({title: "", body: txt, bodyOutputType: 'trustedHtml'});
        }, 500);
    }

    function blurInputBox(id) {
        debugMessage("BLUR CALLED>>>>>>>>>>>> blurInputBox");
        if (document.getElementById(id) !== null && document.getElementById(id) !== undefined) {
            document.getElementById(id).blur();
            if (isTextInput(document.activeElement)) {
                document.activeElement.blur();
            }
        }
    }

    function showcustDialog(myAlertState, msgHeader, popuptext, txtButton1, txtButton2) {
        debugMessage("showcustDialog " + myAlertState + " " + msgHeader + " " + popuptext + " " + txtButton1 + " " + txtButton2);
        $scope.alertState = myAlertState;
        $scope.custPopupTitle = true;
        $scope.custPopupOKBtton = true;
        $scope.showFullScreenPopup = true;
        $scope.custPopupCancelButton = true;
        $scope.custPopupTitleText = msgHeader;
        $scope.custPopupMessageText = popuptext;
        $scope.custPopupCancelOkText = txtButton1;
        $scope.custPopupCancelButtonText = txtButton2;

        $scope.showMenuOptionPopup = false;

        $timeout(function () {
            document.getElementById("fullScreenPopupId").style.zIndex = 999;
            document.getElementById("custPopupDivId").style.zIndex = 999;
        }, 0);
        /*$timeout(function () {
         document.getElementById("bodyTag").style.pointerEvents = 'none';
         }, 200);*/
        $timeout(function () {
            var cHeight = 0, cWidth = 0, popupHeight = 0, base = 0, popupTop = 12;
            cHeight = window.screen.availHeight;
            cWidth = window.screen.availWidth;
            if (cHeight === 0 || cHeight === undefined) {
                cHeight = document.body.clientHeight;
            }
            if (cWidth === 0 || cWidth === undefined) {
                cWidth = document.body.clientWidth;
            }
            base = 2 * ((80 * cWidth) / 1440);
            popupHeight = document.getElementById("custPopupDivId").clientHeight;
            if (popupHeight !== 0 && popupHeight !== undefined && popupHeight !== '' && base > 0) {
                popupTop = (cHeight - popupHeight) / base;
            }
            document.getElementById("custPopupDivId").style.top = popupTop + 'rem';
        }, 10);


        if (msgHeader === undefined || msgHeader === '') {
            $scope.custPopupTitle = false;
        }
        if (txtButton1 === undefined || txtButton1 === '') {
            $scope.custPopupOKBtton = false;
        }
        if (txtButton2 === undefined || txtButton2 === '') {
            $scope.custPopupCancelButton = false;
        }

    }

    function onAlertButton1Click() {
        debugMessage("onAlertButton1Click " + $scope.alertState);
        $scope.showFullScreenPopup = false;
        $timeout(function () {
            switch ($scope.alertState) {
                case HOOD_ALERT_STATE.ALERT_NONE:
                    break;
                case HOOD_ALERT_STATE.ALERT_CONNECTION_ERROR:
                    closeApp();
                    break;
                case HOOD_ALERT_STATE.ALERT_TIMER_FINISH:
                    debugMessage("Hood Timer pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_HOOD_TIMER_FINISH:
                    debugMessage("Hood Timer pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_DEVELOPER_INFO:
                    debugMessage("Developer info pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_CHILD_LOCK:
                    debugMessage("Child lock pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_SERVICE_CALL:
                    callServieCenter();
                    break;
                default:
                    break;
            }
            $scope.alertState = HOOD_ALERT_STATE.ALERT_NONE;
        }, 200);

    }

    function onAlertButton2Click() {
        debugMessage("onAlertButton2Click " + $scope.alertState);
        $scope.showFullScreenPopup = false;
        $timeout(function () {
            switch ($scope.alertState) {
                case HOOD_ALERT_STATE.ALERT_START_COOKING:
                    break;
                case HOOD_ALERT_STATE.ALERT_CONNECTION_ERROR:
                    debugMessage("cancel connection pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_TIMER_FINISH:
                    debugMessage("ok Hood Timer pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_HOOD_TIMER_FINISH:
                    debugMessage("Hood Timer pop up");
                    showHoodScreen();
                    validateCurrentScreen('BurnerHomePage');
                    break;
                case HOOD_ALERT_STATE.ALERT_DEVELOPER_INFO:
                    debugMessage("ok Developer info pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_CHILD_LOCK:
                    debugMessage("ok Child lock pop up");
                    break;
                case HOOD_ALERT_STATE.ALERT_SERVICE_CALL:
                    debugMessage("cancel service center call");
                    break;
                default:
                    break;
            }
            debugMessage("onAlertButton2Click");
            $scope.alertState = HOOD_ALERT_STATE.ALERT_NONE;
        }, 200);
    }

    function smartcareerrorcheck() {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(HOOD_COMMANDS.smartCareDiagnosis);
            debugMessage("Send command for smartCareDiagnosis " + getDiagnosisCommand());
            SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis");
        } else {
            $scope.HoodInfo.Alarms[0].code = "CT_E_F0";
            showCurrentScreen();
        }
    }

    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function getErrorCode(errorEnum) {
        switch (errorEnum) {
            case 'CT_E_d0':
                return "C-d0";
            case 'CT_E_F0':
                return "C-F0";
            case 'CT_E_F1':
                return "C-F1";
            case 'CT_E_F2':
                return "C-F2";
            case 'CT_E_30':
                return "C-30";
            case 'CT_E_31':
                return "C-31";
            case 'CT_E_A2':
                return "C-A2";
            case 'CT_E_C0':
                return "C-C0";
            case 'CT_E_C1':
                return "C-C1";
            case 'CT_E_C2':
                return "C-C2";
            case 'undefined':
            default:
                return "";
        }
    }

    function getAlarmStatusHood() {
        //$scope.HoodInfo.Alarms[0].code = "CT_E_F0";
        if ($scope.HoodInfo.Alarms[0] !== undefined && $scope.HoodInfo.Alarms[0] !== null && $scope.HoodInfo.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 0 :' + $scope.HoodInfo.Alarms[0].code);

            if ($scope.HoodInfo.Alarms[0].code === 'CT_E') {
                $scope.HoodInfo.Alarms[0].code = '-1';
                errorRemoved = true;
                return false;
            }

            if (!errorRemoved) {
                debugMessage('Check error status');
                return;
            }

            if ($scope.HoodInfo.Alarms[0].code.indexOf("CT_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.HoodInfo.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    errorRemoved = false;
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            }
        }
        return false;
    }

    function doOnServiceCallPopup() {
        showcustDialog(HOOD_ALERT_STATE.ALERT_SERVICE_CALL, $scope.translation.WEBMOB_common_service_call, ($scope.translation.WEBMOB_common_connect_service_call) + "<br>" + $scope.serviceCenterNumber, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
    }

    function callServieCenter() {
        debugMessage("call service center");
        nativeInterface.runOnNative("callDial", '{"selectedCountry" : "' + $scope.selectedCountry + '"}');
    }

    function aboutCommand(cmdstring) {
        return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
    }

    window.onresize = updateScrollableHeight;
    $scope.$watch(function () {
        return angular.isDefined(scroll_middle_area[0]) && scroll_middle_area[0].offsetTop;
    }, function () {
        updateScrollableHeight();
    });

    /**
     * Update the height of the scrolalbe area.
     */
    function updateScrollableHeight() {
        $timeout(function () {
            var scrollableElement = scroll_middle_area[0];
            var area4 = document.getElementsByClassName('ap-search-list-property');
            if (scrollableElement) {
                var screenSize = document.body.clientHeight,
                        scrollableOffsetTop = scrollableElement.getBoundingClientRect().top;
                //set new height to scrollable area
                scrollableElement.style.height = (screenSize - scrollableOffsetTop) + "px";
            }
            if (area4.length > 0) {
                var scrollableElement = area4[0],
                        screenSize = document.body.clientHeight,
                        scrollableOffsetTop = scrollableElement.getBoundingClientRect().top;
                scrollableElement.style.height = (screenSize - scrollableOffsetTop) + "px";
            }
        }, 100);
    }

    if ($scope.isStatic) {
        parseStaticData();
    }
}

app.directive('stPressEffect', function (UtilityService) {
    return {
        restrict: 'A',
        link: function ($scope, $elm, $attrs) {
            var mouseEvts = {
                'touchstart': touchStartFun,
                'touchend': touchEndFun,
                'touchleave': touchEndFun,
                'touchcancel': touchEndFun,
                'touchmove': touchMoveFun
            },
            evnt;
            for (evnt in mouseEvts) {
                if (mouseEvts.hasOwnProperty(evnt) &&
                        UtilityService.isEventSupported(evnt)) {
                    $elm.bind(evnt, mouseEvts[evnt]);
                }
            }
            function touchStartFun() {
                $scope.$parent[$attrs.stPressEffect] = true;
                $scope.$apply();
            }
            function touchMoveFun(evt) {
                if (evt.touches !== undefined && evt.touches.length !== undefined && evt.touches[evt.touches.length - 1] !== undefined && evt.currentTarget !== undefined && evt.currentTarget.parentElement !== undefined) {
                    if (evt.touches[evt.touches.length - 1].clientY <= evt.currentTarget.parentElement.clientHeight || evt.touches[evt.touches.length - 1].clientX <= evt.currentTarget.parentElement.clientWidth) {
                        touchStartFun();
                    }
                } else {
                    touchEndFun();
                }
            }
            function touchEndFun() {
                $scope.$parent[$attrs.stPressEffect] = false;
                $scope.$apply();
            }
        }
    };
});

function updateKitchenTimerValue(value, tab) {
    var scope = angular.element($("#bodyTag")).scope();
    scope.hoodTimer = Number(value);
    scope.updateHoodTimerValue(scope.hoodTimer);
    if (scope.$root.$$phase !== '$apply' && scope.$root.$$phase !== '$digest') {
        scope.$apply();
    }
}